# coding: utf-8

import numpy as np

import scipy
import scipy.optimize

import matplotlib.pyplot as plt

from ode45 import ode45

# TODO implementieren Sie hier die Funktionen welche Sie später aufrufen
# wollen.

def plot_phase_diagram(alpha, dalpha_dt):
    """Plottet die Evolution der beiden Teilchen.

    Input:
          alpha : 1d-array.
                  Auslenkungswinkel.

      dalpha_dt : 1d-array.
                  Winkelgeschwindigkeit.

    """
    plt.figure()

    # TODO Plotten Sie die Lösung im Phasenraum.

    plt.xlabel(r"$\alpha$")
    plt.ylabel(r"$\dot{\alpha}$")
    plt.gca().set_aspect('equal')

    plt.savefig("1_pendulum-phase.png")

def plot_convergence(resolution, err):
    """ Plottet die Konvergenz.

    Input:
        resolution : 1d-array.
                     Array mit den Anzahl Zeitschritten mit der die Lösung
                     approximiert wurde.

            errors : 1d-array.
                     Array mit dem Fehler.
    """
    plt.figure()
    plt.loglog(resolution, err, "x-", label="Impl. Mittelpunkt")

    plt.legend(loc=3)

    plt.xlabel("Anzahl Zeitschritte")
    plt.ylabel("Fehler")

    plt.savefig("1_pendulum-convergence.png")


if __name__ == "__main__":
    # TODO lösen Sie Teilaufgabe c)
    #   Vergessen Sie nicht die plotting Funktion aufzurufen.

    # TODO lösen Sie Teilaufgabe d)
    #   Vergessen Sie nicht die plotting Funktion aufzurufen.

    order = 0.0   # TODO numerisch berechnete Konvergenzordnung
    print("order = {:f}".format(order))
