#! -*- encoding: utf-8 -*-

import numpy as np
import numpy.linalg
import scipy.optimize
import matplotlib.pyplot as plt

k1, k2, k3 = 0.1, 1e1, 1e3

def f(y):
    """Rechte Seite der Differenzialgleichung."""

    # TODO implementieren Sie die rechte Seite.
    return np.array([0.0])

def df(y):
    """Jacobimatrix der Funktion `f`."""

    # TODO implementieren Sie die Jacobimatrix von `f`.
    return np.array([0.0])

def integrate(f, df, y0, t_end, dt_guess, atol):
    """Berechnet eine approximative Lösung der Differenzialgleichung.

    Input:
               f : Rechte Seite der DGL.
              df : Jacobimatrix der rechten Seite der DGL.
              y0 : Startwert der DGL.
           t_end : Simulationsdauer.
        dt_guess : Schrittweite der ersten Iteration.
            atol : Absolute Toleranz des approximativen Fehlers.
    """

    # TODO Implementieren Sie den Löser `ode23s`.

    t = np.empty((1,)) # TODO, fix me.
    y = np.empty((1,3)) # TODO, fix me.

    return t, y

def compute_solution(t_end):
    y0 = np.array([1.0, 0.0, 0.0])
    t, y = integrate(f, df, y0, t_end, 0.001, atol=1e-5)
    plot_solution(t, y)

    return t, y

def plot_solution(t, y):
    plt.plot(t, y[:,0], label="A")
    plt.plot(t, y[:,1], label="B")
    plt.plot(t, y[:,2], label="C")

    plt.xlabel("Zeit")
    plt.ylabel("Stoffmenge")
    plt.legend(loc="best")

    plt.savefig("5_reaction_network.png", dpi=300)

if __name__ == "__main__":
    t_end = 5000
    t, y = compute_solution(t_end)

    # TODO berechne den index bei der sich die Lösung auf die gewünschte
    # Genauigkeit an die exakten Gleichgewichtsstoffmengen angepasst hat.
    k_min = 0  # TODO.

    print("t_min = {:.3e}".format(t[k_min]))
    print("A(t_min) = {:.3e}".format(y[k_min,0]))
    print("B(t_min) = {:.3e}".format(y[k_min,1]))
    print("C(t_min) = {:.3e}".format(y[k_min,2]))

    # TODO, falls Sie den Plot nicht anzeigen wollen, kommentieren Sie die
    # nächste Zeile aus.
    plt.show()
